// this might be the smalles possible program to check whether a string is a
// well-formed arithmetic expression. by Viktor Engelmann, license: GPL3

int main(int argc, char** argv)
{
	if(argc <= 1)
		return 1;
	char* s = argv[1];
	int x = 0;
	a:	if(*s == '(') { x++; s++; goto a; }
		if('0' > *s || *s > '9') return 1;
	b:	if('0' <= *s && *s <= '9') { s++; goto b; }
	c:	if(*s == '+'  || *s == '-' || *s == '*' || *s == '/') { s++; goto a; }
		if(*s == ')') { if(--x<0) return 1; s++; goto c; }
	return *s == '\0' && x == 0;
}	

/*
alternative version
===================
int main(int argc, char** argv) {
	if(argc <= 1) return(1);
	char* s = argv[1]-1;
	int x = 0;
	do {
		while(*(++s) == '(') { x++; s++; }
		if('0' > *s || *s > '9') exit(1);
		while('0' <= *s && *s <= '9') s++;
		while(*s == ')') { if(--x<0) exit(1); s++;}
	} while(*s == '+'  || *s == '-' || *s == '*' || *s == '/');
	if(*s != '\0' || x != 0) return(1);
	return 0;
*/
